package org.gidea.scada.monitor.rabbit.listener;

import com.alibaba.fastjson.JSONObject;
import com.rabbitmq.client.Channel;
import lombok.extern.log4j.Log4j2;
import org.gidea.scada.monitor.rabbit.entity.MonitorMessage;
import org.gidea.scada.monitor.udp.entity.CjdMessage;
import org.gidea.scada.monitor.utils.RabbitExchangeEnum;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.io.IOException;

@Log4j2
@Component
public class CjdListenerHandler {
    @Resource
    private Channel channel;

    public void handler(CjdMessage message) {
        MonitorMessage monitorMessage = new MonitorMessage();
        BeanUtils.copyProperties(message, monitorMessage);
        try {
            channel.basicPublish(RabbitExchangeEnum.MonitorCommandClient.exchangeName, "", null, JSONObject.toJSONString(monitorMessage).getBytes());
        } catch (IOException e) {
            log.error("响应消息失败！{}", JSONObject.toJSONString(message), e);
            throw new RuntimeException(e);
        }
    }


}
