package org.gidea.scada.monitor.rabbit.service.impl;

import org.gidea.scada.monitor.rabbit.entity.ExchangeEntity;
import org.gidea.scada.monitor.rabbit.entity.Result;
import org.gidea.scada.monitor.rabbit.service.MonitorRabbitService;
import org.springframework.amqp.core.FanoutExchange;
import org.springframework.amqp.rabbit.core.RabbitAdmin;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class MonitorRabbitServiceImpl implements MonitorRabbitService {

    @Resource
    private RabbitAdmin rabbitAdmin;

    @Override
    public Result<ExchangeEntity> applyConnection(String deviceId) {
        ExchangeEntity exchange = new ExchangeEntity(deviceId);
        FanoutExchange dataExchange = new FanoutExchange(exchange.getMonitorDeviceData(), false, false);
        FanoutExchange jhExchange = new FanoutExchange(exchange.getMonitorDeviceJh(), false, false);
        rabbitAdmin.declareExchange(dataExchange);
        rabbitAdmin.declareExchange(jhExchange);
        return Result.success(exchange);
    }

}
