package org.gidea.scada.monitor.udp.utils;

public class CrcUtils {

    public static String getCrc(byte[] data) {
        int crc = 0xFFFF;
        int len = data.length;
        for (int i = 0; i < len; i++) {
            crc = (crc ^ (data[i] & 0xFF));
            for (int j = 0; j < 8; j++) {
                crc = (crc & 1) != 0 ? ((crc >> 1) ^ 0xA001) : (crc >> 1);
            }
        }
        byte hi = (byte) ((crc & 0xFF00) >> 8);  // 高位置
        byte lo = (byte) (crc & 0x00FF);         // 低位置
        String low = String.format("%02X", lo);
        String high = String.format("%02X", hi);
        return low + high;
    }

}
